> ## Documentation Index
> Fetch the complete documentation index at: https://docs.vellaro.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List Products

> Public paginated product listing with filters.



## OpenAPI

````yaml https://api.vellaro.io/openapi.json get /api/v1/products
openapi: 3.1.0
info:
  title: Vellaro API
  description: Vellaro 2026 — E-commerce API
  version: 0.1.0
servers:
  - url: https://api.vellaro.io
    description: Produzione
security: []
tags: []
paths:
  /api/v1/products:
    get:
      tags:
        - products
      summary: List Products
      description: Public paginated product listing with filters.
      operationId: list_products_api_v1_products_get
      parameters:
        - name: page
          in: query
          required: false
          schema:
            type: integer
            minimum: 1
            default: 1
            title: Page
        - name: page_size
          in: query
          required: false
          schema:
            type: integer
            maximum: 100
            minimum: 1
            default: 24
            title: Page Size
        - name: category_id
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: uuid
              - type: 'null'
            title: Category Id
        - name: brand_id
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                format: uuid
              - type: 'null'
            title: Brand Id
        - name: is_featured
          in: query
          required: false
          schema:
            anyOf:
              - type: boolean
              - type: 'null'
            title: Is Featured
        - name: in_stock
          in: query
          required: false
          schema:
            anyOf:
              - type: boolean
              - type: 'null'
            title: In Stock
        - name: min_price
          in: query
          required: false
          schema:
            anyOf:
              - type: number
              - type: string
                pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
              - type: 'null'
            description: Minimum price filter
            title: Min Price
          description: Minimum price filter
        - name: max_price
          in: query
          required: false
          schema:
            anyOf:
              - type: number
              - type: string
                pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
              - type: 'null'
            description: Maximum price filter
            title: Max Price
          description: Maximum price filter
        - name: q
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Text search on name
            title: Q
          description: Text search on name
        - name: sort
          in: query
          required: false
          schema:
            type: string
            pattern: ^(sort_order|name|-name|price|-price|created_at|-created_at)$
            default: sort_order
            title: Sort
        - name: lang
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Force content language (it|en|sq)
            title: Lang
          description: Force content language (it|en|sq)
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiResponse_list_ProductListOut__'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
components:
  schemas:
    ApiResponse_list_ProductListOut__:
      properties:
        data:
          anyOf:
            - items:
                $ref: '#/components/schemas/ProductListOut'
              type: array
            - type: 'null'
          title: Data
        meta:
          anyOf:
            - $ref: '#/components/schemas/PaginationMeta'
            - type: 'null'
        error:
          anyOf:
            - type: string
            - type: 'null'
          title: Error
        error_code:
          anyOf:
            - type: string
            - type: 'null'
          title: Error Code
      type: object
      title: ApiResponse[list[ProductListOut]]
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ProductListOut:
      properties:
        id:
          type: string
          format: uuid
          title: Id
        name:
          type: string
          title: Name
        slug:
          type: string
          title: Slug
        short_description:
          anyOf:
            - type: string
            - type: 'null'
          title: Short Description
        name_i18n:
          anyOf:
            - additionalProperties: true
              type: object
            - type: 'null'
          title: Name I18N
        category_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Category Id
        brand_id:
          anyOf:
            - type: string
              format: uuid
            - type: 'null'
          title: Brand Id
        is_featured:
          type: boolean
          title: Is Featured
        is_active:
          type: boolean
          title: Is Active
        sort_order:
          type: integer
          title: Sort Order
        created_at:
          type: string
          format: date-time
          title: Created At
        price:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Price
        sale_price:
          anyOf:
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
            - type: 'null'
          title: Sale Price
        sku:
          anyOf:
            - type: string
            - type: 'null'
          title: Sku
        stock:
          anyOf:
            - type: integer
            - type: 'null'
          title: Stock
        stock_status:
          anyOf:
            - type: string
              enum:
                - in
                - low
                - out
            - type: 'null'
          title: Stock Status
        primary_image_url:
          anyOf:
            - type: string
            - type: 'null'
          title: Primary Image Url
      type: object
      required:
        - id
        - name
        - slug
        - short_description
        - category_id
        - brand_id
        - is_featured
        - is_active
        - sort_order
        - created_at
      title: ProductListOut
      description: Lightweight DTO for listing — no variants detail.
    PaginationMeta:
      properties:
        page:
          type: integer
          title: Page
        page_size:
          type: integer
          title: Page Size
        total:
          type: integer
          title: Total
        total_pages:
          type: integer
          title: Total Pages
      type: object
      required:
        - page
        - page_size
        - total
        - total_pages
      title: PaginationMeta
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
        ctx:
          type: object
          title: Context
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError

````